package com.uca.dao;

import com.uca.entity.ProfEntity;

import java.sql.*;
import java.util.ArrayList;

public class ProfDAO extends _Generic<ProfEntity> {

    public ArrayList<ProfEntity> getAllProfs() {
        ArrayList<ProfEntity> entities = new ArrayList<>();
        try {
            PreparedStatement preparedStatement = this.connect.prepareStatement("SELECT * FROM profs ORDER BY id ASC;");
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                ProfEntity entity = new ProfEntity();
                entity.setId(resultSet.getInt("id"));
                entity.setFirstName(resultSet.getString("firstName"));
                entity.setLastName(resultSet.getString("lastName"));
                entity.setUserName(resultSet.getString("userName"));
                entities.add(entity);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return entities;
    }

    @Override
    public ProfEntity create(ProfEntity obj) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("insert into profs (id, firstName, lastName, userName) values (?, ?, ?, ?);");
            int idx = 1;
            stmt.setInt   (idx++, obj.getId());
            stmt.setString(idx++, obj.getFirstName());
            stmt.setString(idx++, obj.getLastName());
            stmt.setString(idx++, obj.getUserName());
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public void delete(ProfEntity obj) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("DELETE FROM profs WHERE id = ?;");
            stmt.setInt   (1, obj.getId());
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }
}
